#include <solve.hpp>
using namespace ngsolve;
using namespace ngfem;
#include <python_comp.hpp>
#include "ElementWeightCF.hpp"


// C++ to Python

PYBIND11_MODULE(cppextension,m) {
  // import ngsolve such that python base classes are defined
  auto ngs = py::module::import("ngsolve");

  /*
    In python, classes are objects as well. Therefore we need to create all the class-objects
    we need in our module.
    py::class_ is a template class, which creates python classes.
    The first template parameter of is the class of the object we want to export, the order
    of the other template parameters doesn't matter, for consistency we declare next the holder
    type and then the base class(es).
    The holder type is either unique_ptr (default) or shared_ptr. In most cases we need shared_ptr,
    since we pass our objects to c++ code which may outlive our python objects.
    After that you specify already exported base classes for your object. Note that you do not
    specify not exported bases (since Python does not know anything about them).
    The constructor for our class object takes the module, a string as the class name in Python
    and another string for the docstring of the object. This string is displayed if you
    call the function 'help' on the object.
   */

  /*
    Finally we export all the other classes and functions we created in this tutorial
   */
   
  ExportElementWeightCF(m);

  // This adds documented flags to the docstring of objects 
  
  ngs.attr("_add_flags_doc")(m);
}

